/*
 * Copyright (c) 2010-2011, The MiCode Open Source Community (www.micode.net)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

 package net.micode.notes.ui;

 import android.content.BroadcastReceiver;
 import android.content.Context;
 import android.content.Intent;
 
 /**
  * AlarmReceiver 类继承自 BroadcastReceiver，用于接收闹钟广播。
  * 当接收到闹钟广播时，会启动 AlarmAlertActivity 来处理闹钟提醒。
  */
 public class AlarmReceiver extends BroadcastReceiver {
     /**
      * 当接收到广播时调用该方法。
      * @param context 上下文对象
      * @param intent 接收到的广播意图
      */
     @Override
     public void onReceive(Context context, Intent intent) {
         // 设置意图的目标类为 AlarmAlertActivity
         intent.setClass(context, AlarmAlertActivity.class);
         // 添加新任务标志，确保可以在新任务中启动 Activity
         intent.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
         // 启动 AlarmAlertActivity
         context.startActivity(intent);
     }
 }